---
title: CSSMathSum
slug: Web/API/CSSMathSum
tags:
  - API
  - CSS Typed Object Model API
  - CSSMathSum
  - Experimental
  - Houdini
  - Interface
  - Reference
---
<div>{{draft}}{{APIRef("CSS Typed Object Model API")}}{{SeeCompatTable}}</div>

<p class="summary">The <strong><code>CSSMathSum</code></strong> interface of the {{domxref('CSS Typed Object Model API','','',' ')}} represents the result obtained by calling {{domxref('CSSNumericValue.add','add()')}}, {{domxref('CSSNumericValue.sub','sub()')}}, or {{domxref('CSSNumericValue.toSum','toSum()')}} on {{domxref('CSSNumericValue')}}.</p>

<p class="summary">A CSSMathSum is the object type returned when the  <code><a href="/en-US/docs/Web/API/StylePropertyMapReadOnly/get">StylePropertyMapReadOnly.get()</a></code> method is used on a CSS property whose value is created with a <code><a href="/en-US/docs/Web/CSS/calc">calc()</a></code> function.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("CSSMathSum.CSSMathSum()")}}</dt>
 <dd>Creates a new <code>CSSMathSum</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('CSSMathSum.values')}}</dt>
 <dd>Returns a {{domxref('CSSNumericArray')}} object which contains one or more {{domxref('CSSNumericValue')}} objects.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<p>No</p>

<h2 id="Methods">Methods</h2>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>We create an element with a <code><a href="/en-US/docs/Web/CSS/width">width</a></code> determined using a <code><a href="/en-US/docs/Web/CSS/calc">calc()</a></code> function, then <code><a href="/en-US/docs/Web/API/Console/log">console.log()</a></code> the <code>operator</code> and <code>values</code>, and dig into the values a bit.</p>

<pre class="brush: html notranslate">&lt;div&gt;has width&lt;/div&gt;
</pre>

<p>We assign a <code>width</code></p>

<pre class="brush: css notranslate">div {
  width: calc(30% - 20px);
}</pre>

<p>We add the JavaScript</p>

<pre class="brush: js notranslate">const styleMap = document.querySelector('div').computedStyleMap();

console.log( styleMap.get('width') );                  // CSSMathSum {values: CSSNumericArray, operator: "sum"}
console.log( styleMap.get('width').operator );         // 'sum'
console.log( styleMap.get('width').values );           // CSSNumericArray {0: CSSUnitValue, 1: CSSUnitValue, length: 2}
console.log( styleMap.get('width').values[0] );        // <a href="/en-US/docs/Web/API/CSSUnitValue">CSSUnitValue</a> {value: 30, unit: "percent"}
console.log( styleMap.get('width').values[0].value );  // 30
console.log( styleMap.get('width').values[0].unit );   // 'percent'
console.log( styleMap.get('width').values[1] );        // CSSUnitValue {value: -20, unit: "px"}
console.log( styleMap.get('width').values[1].value );  //  -20
console.log( styleMap.get('width').values[1].unit );   // 'px'
</pre>

<p>{{EmbedLiveSample("Examples", 120, 300)}}</p>

<p>The specification is still evolving. In the future we may write the last three lines as:</p>

<pre class="notranslate">console.log( styleMap.get('width').values[1] );            // CSSMathNegate {value: CSSUnitValue, operator: "negate"}
console.log( styleMap.get('width').values[1].value );      // CSSUnitValue {value: 20, unit: "px"}
console.log( styleMap.get('width').values[1].value.unit ); // 'px'</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSS Typed OM','#cssmathsum','CSSMathSum')}}</td>
   <td>{{Spec2('CSS Typed OM')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSMathSum")}}</p>
